#include "project.h"
#include "stdio.h"
#include "tty_utils.h"
#include "func_list.h"

void do_help(void) ;
void do_spi(void) ;
void do_gpio(void) ;
void do_i2c(void) ;
void do_adc(void) ;
void do_pwm(void) ;
void do_mem(void) ;

f_list_type main_func_list[] = {
    { "help", do_help, "show help message" },
    { "mem",  do_mem,  "memory test" },
    { "pwm",  do_pwm,  "pwm test" },
    { "adc",  do_adc,  "adc test" },
    { "i2c",  do_i2c,  "i2c test" },
    { "gpio", do_gpio, "gpio test" },
    { "spi",  do_spi,  "spi test" },
    { 0,      0,       0} /* list terminator */
} ;

void init_hardware(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */   
    tty_init() ;
}

int main(void)
{
    func_ptr func ;
    
    init_hardware() ;
    
    splash("MCU Tester") ;
    
    do_help() ;

    prompt("> ") ;
    for(;;)
    {
        if (get_line()) {
            func = get_func(main_func_list, str) ;
            if (func) {
                func() ;
            } else {
                print("Unknown Command: ") ;
                print(str) ;
                print("\r\n") ;
                do_help() ;
            }
            prompt("> ") ;
        }   
    }
}

void do_help(void)
{
    show_help(main_func_list) ;
}